Bug 48297

Summary: webservices.ServiceRefFactory.initHandlerChain adds wrong items to list?
Product: Tomcat 7 Reporter: Sebb <sebb>
Component: CatalinaAssignee: Tomcat Developers Mailing List <dev>
Status: RESOLVED FIXED    
Severity: normal    
Priority: P2    
Version: trunk   
Target Milestone: ---   
Hardware: PC   
OS: Windows XP   

Description Sebb 2009-11-28 19:01:37 UTC
naming.factory.webservices.ServiceRefFactory.initHandlerChain method does the following:

HandlerInfo handlerref (parameter)
HandlerChain handlerList = (HandlerChain) handlerRegistry.getHandlerChain(portName);
handlerList.add(handlerref);

Now according to http://www.j2ee.me/j2ee/1.4/docs/api/javax/xml/rpc/handler/HandlerChain.html HandlerChain, "All elements in the HandlerChain are of the type javax.xml.rpc.handler.Handler."

However HandlerInfo (javax.xml.rpc.handler.HandlerInfo) is not of the type Handler. HandlerInfo should be passed to the init() method of a Handler instance.
Comment 1 Mark Thomas 2009-11-30 16:47:17 UTC
Note that due to a data loss on 26/27 Nov 2009 the issue that was originally created as bug 48297 was lost. It has been re-created as bug 48308.
Comment 2 Mark Thomas 2010-07-08 18:23:45 UTC
Fixed in 7.0.x and will be included in 7.0.1 onwards.

I don;t have a test case so the fix is based on a review of the JavaDoc and a review of the code.